-- I based this GUI on the one used in the BadBoy anti-spam addon.
-- Consequently, I owe many thanks to Funkydude; permission was given to use his addon in this way.
-- Get BadBoy Anti-Spam here: https://mods.curse.com/addons/wow/bad-boy

local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

function DRWOptionsFrame_OnLoad()
SlashCmdList["DRWOPTIONS"] = drwoptions_command
	SLASH_DRWOPTIONS1 = "/drw"
	
StaticPopupDialogs["RESET_DRWVARIABLES"] = {
  text = L["Reset SavedVariables"] .. "\n\n" .. L["Are you sure?"],
  button1 = L["Yes"],
  button2 = L["No"],
  OnAccept = function()
      resetdrwvariables()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}
end

function resetdrwvariables()

DRWConfig = {
	["SendMsg"] = 'ON',
	["AllDuels"] = 'Sorry, but I do not duel.',
	["AFKDuel"] = 'I am currently AFK.',
	["DNDDuel"] = 'Sorry, but I am busy at the moment.',
	["HLDuel"] = 'I am currently experiencing a lot of lag.',
	["LowFPS"] = 'I am currently experiencing a low framerate.',
	["OptionsWindow"] = 'HIDDEN',
	["AFKMessage"] = 'AFK.',
	["PetBattle"] = 'Sorry, but I am not into Pet Battles.',
	["WhisperBlacklist"] = 'OFF',
	["BLWhisperMsg"] = 'I am not accepting duels from you.'
}

DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Settings returned to default values."])

end

function drwoptions_command(msg, editbox)

if msg == "" or msg == nil then
	
if DRWConfig.OptionsWindow == "VISIBLE" then
	return
elseif DRWConfig.OptionsWindow == "HIDDEN" then
	DRWConfig.OptionsWindow = 'VISIBLE'
local drwoptions = CreateFrame("Frame", "DRConfig", UIParent)
if GetLocale() ~= "deDE" then
	drwoptions:SetSize(575, 375) -- WxH
elseif GetLocale() == "deDE" then
	drwoptions:SetSize(600, 375) -- WxH
end
drwoptions:SetPoint("CENTER")
drwoptions:SetClampedToScreen(true)
drwoptions:EnableMouse(true)
drwoptions:SetMovable(true)
drwoptions:RegisterForDrag("LeftButton")
drwoptions:SetScript("OnDragStart", function(self) self:StartMoving() end)
drwoptions:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
drwoptions:Show()
local bg = drwoptions:CreateTexture()
bg:SetAllPoints(drwoptions)
bg:SetColorTexture(0, 0, 0, 0.5)
local hidedrwoptions = CreateFrame("Button", nil, drwoptions, "UIPanelCloseButton")
hidedrwoptions:SetPoint("TOPRIGHT", drwoptions, "TOPRIGHT", -5, -5)

drwoptions:SetScript("OnHide", function(frame)
	DRWConfig.OptionsWindow = 'HIDDEN'
	
	if DRWConfig.AllDuels == "" then
		DRWConfig.AllDuels = 'Sorry, but I do not duel.'
	end
	
	if DRWConfig.AFKDuel == "" then
		DRWConfig.AFKDuel = 'I am currently AFK.'
	end
	
	if DRWConfig.DNDDuel == "" then
		DRWConfig.DNDDuel = 'Sorry, but I am busy at the moment.'
	end
	
	if DRWConfig.HLDuel == "" then
		DRWConfig.HLDuel = 'I am currently experiencing a lot of lag.'
	end
	
	if DRWConfig.LowFPS == "" then
		DRWConfig.LowFPS = 'I am currently experiencing a low framerate.'
	end
	
	if DRWConfig.PetBattle == "" then
		DRWConfig.PetBattle = 'Sorry, but I am not into Pet Battles.'
	end
	
	if DRWConfig.BLWhisperMsg == "" then
		DRWConfig.BLWhisperMsg= 'I am not accepting duels from you.'
	end
end)

local title = drwoptions:CreateFontString(nil, nil, "GameFontNormalLarge")
title:SetPoint("TOPLEFT", 16, -16)
title:SetText(L["DuelResponse_Whisper"])

-- Send Whispers Checkbox

local chkSendWhisper = CreateFrame("CheckButton", nil, drwoptions, "OptionsBaseCheckButtonTemplate")
chkSendWhisper:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -16)

	if DRWConfig.SendMsg == "ON" then
		chkSendWhisper:SetChecked(true)
	elseif DRWConfig.SendMsg == "OFF" then
		chkSendWhisper:SetChecked(false)
	end

chkSendWhisper:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRWConfig.SendMsg = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Whisper messages disabled."])
	elseif tick == true then
		DRWConfig.SendMsg = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Whisper messages enabled."])
	end
end)

local chkSendWhisperText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
chkSendWhisperText:SetPoint("LEFT", chkSendWhisper, "RIGHT", 0, 1)
chkSendWhisperText:SetText(L["Send a whisper when a duel is declined"])

-- Load Message Checkbox

local chkShowLoadMsg = CreateFrame("CheckButton", nil, drwoptions, "OptionsBaseCheckButtonTemplate")
chkShowLoadMsg:SetPoint("TOPLEFT", chkSendWhisper, "BOTTOMLEFT", 0, -8)

	if DRWConfig.ShowLoadMessage == "ON" then
		chkShowLoadMsg:SetChecked(true)
	elseif DRWConfig.ShowLoadMessage == "OFF" then
		chkShowLoadMsg:SetChecked(false)
	end

chkShowLoadMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRWConfig.ShowLoadMessage = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Welcome message disabled."])
	elseif tick == true then
		DRWConfig.ShowLoadMessage = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse_Whisper"] .."]|r " .. L["Welcome message enabled."])
	end
end)

local chkShowLoadMsgText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
chkShowLoadMsgText:SetPoint("LEFT", chkShowLoadMsg, "RIGHT", 0, 1)
chkShowLoadMsgText:SetText(L["Welcome message"])

-- Block All Duels Whisper Editbox

local lblDeclineAllDuelsText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineAllDuelsText:SetPoint("TOPLEFT", chkShowLoadMsg, "BOTTOMLEFT", 0, -16)
lblDeclineAllDuelsText:SetText(L["Standard Whisper:"])

local txtDeclineAllDuels = CreateFrame("EditBox", nil, drwoptions, "InputBoxTemplate")
txtDeclineAllDuels:SetPoint("LEFT", lblDeclineAllDuelsText, "RIGHT", 16, 0)
txtDeclineAllDuels:SetAutoFocus(false)
txtDeclineAllDuels:SetWidth(350)
txtDeclineAllDuels:SetHeight(16)
txtDeclineAllDuels:SetMaxLetters(255)
txtDeclineAllDuels:Show()

local text = DRWConfig.AllDuels
		txtDeclineAllDuels:SetText(text)

txtDeclineAllDuels:SetScript("OnLeave", GameTooltip_Hide)
txtDeclineAllDuels:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRWConfig.AllDuels = text
end)

-- AFK Duels Whisper Editbox

local lblDeclineAFKDuelsText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineAFKDuelsText:SetPoint("TOPLEFT", lblDeclineAllDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclineAFKDuelsText:SetText(L["Away Whisper:"])

local txtDeclineAFKDuels = CreateFrame("EditBox", nil, drwoptions, "InputBoxTemplate")
txtDeclineAFKDuels:SetPoint("LEFT", lblDeclineAFKDuelsText, "RIGHT", 16, 0)
txtDeclineAFKDuels:SetAutoFocus(false)
txtDeclineAFKDuels:SetWidth(350)
txtDeclineAFKDuels:SetHeight(16)
txtDeclineAFKDuels:SetMaxLetters(255)
txtDeclineAFKDuels:Show()

local text = DRWConfig.AFKDuel
		txtDeclineAFKDuels:SetText(text)

txtDeclineAFKDuels:SetScript("OnLeave", GameTooltip_Hide)
txtDeclineAFKDuels:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRWConfig.AFKDuel = text
end)

-- DND Duels Whisper Editbox

local lblDeclineDNDDuelsText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineDNDDuelsText:SetPoint("TOPLEFT", lblDeclineAFKDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclineDNDDuelsText:SetText(L["Busy Whisper:"])

local txtDeclineDNDDuels = CreateFrame("EditBox", nil, drwoptions, "InputBoxTemplate")
txtDeclineDNDDuels:SetPoint("LEFT", lblDeclineDNDDuelsText, "RIGHT", 16, 0)
txtDeclineDNDDuels:SetAutoFocus(false)
txtDeclineDNDDuels:SetWidth(350)
txtDeclineDNDDuels:SetHeight(16)
txtDeclineDNDDuels:SetMaxLetters(255)
txtDeclineDNDDuels:Show()

local text = DRWConfig.DNDDuel
		txtDeclineDNDDuels:SetText(text)

txtDeclineDNDDuels:SetScript("OnLeave", GameTooltip_Hide)
txtDeclineDNDDuels:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRWConfig.DNDDuel = text
end)

-- High Latency Whisper Editbox

local lblDeclineHighLatencyDuelsText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineHighLatencyDuelsText:SetPoint("TOPLEFT", lblDeclineDNDDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclineHighLatencyDuelsText:SetText(L["High Latency Whisper:"])

local txtDeclineHighLatencyDuels = CreateFrame("EditBox", nil, drwoptions, "InputBoxTemplate")
txtDeclineHighLatencyDuels:SetPoint("LEFT", lblDeclineHighLatencyDuelsText, "RIGHT", 16, 0)
txtDeclineHighLatencyDuels:SetAutoFocus(false)
txtDeclineHighLatencyDuels:SetWidth(350)
txtDeclineHighLatencyDuels:SetHeight(16)
txtDeclineHighLatencyDuels:SetMaxLetters(255)
txtDeclineHighLatencyDuels:Show()

local text = DRWConfig.HLDuel
		txtDeclineHighLatencyDuels:SetText(text)

txtDeclineHighLatencyDuels:SetScript("OnLeave", GameTooltip_Hide)
txtDeclineHighLatencyDuels:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRWConfig.HLDuel = text
end)

-- Low FPS Whisper Editbox

local lblDeclineLowFPSDuelsText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclineLowFPSDuelsText:SetPoint("TOPLEFT", lblDeclineHighLatencyDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclineLowFPSDuelsText:SetText(L["Low FPS Whisper:"])

local lblDeclineLowFPSDuels = CreateFrame("EditBox", nil, drwoptions, "InputBoxTemplate")
lblDeclineLowFPSDuels:SetPoint("LEFT", lblDeclineLowFPSDuelsText, "RIGHT", 16, 0)
lblDeclineLowFPSDuels:SetAutoFocus(false)
lblDeclineLowFPSDuels:SetWidth(350)
lblDeclineLowFPSDuels:SetHeight(16)
lblDeclineLowFPSDuels:SetMaxLetters(255)
lblDeclineLowFPSDuels:Show()

local text = DRWConfig.LowFPS
		lblDeclineLowFPSDuels:SetText(text)

lblDeclineLowFPSDuels:SetScript("OnLeave", GameTooltip_Hide)
lblDeclineLowFPSDuels:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRWConfig.LowFPS = text
end)

-- Decline Pet Battle Whisper Editbox

local lblDeclinePetBattleText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
lblDeclinePetBattleText:SetPoint("TOPLEFT", lblDeclineLowFPSDuelsText, "BOTTOMLEFT", 0, -16)
lblDeclinePetBattleText:SetText(L["Pet Battle Refused:"])

local lblDeclinePetBattle = CreateFrame("EditBox", nil, drwoptions, "InputBoxTemplate")
lblDeclinePetBattle:SetPoint("LEFT", lblDeclinePetBattleText, "RIGHT", 16, 0)
lblDeclinePetBattle:SetAutoFocus(false)
lblDeclinePetBattle:SetWidth(350)
lblDeclinePetBattle:SetHeight(16)
lblDeclinePetBattle:SetMaxLetters(255)
lblDeclinePetBattle:Show()

local text = DRWConfig.PetBattle
		lblDeclinePetBattle:SetText(text)

lblDeclinePetBattle:SetScript("OnLeave", GameTooltip_Hide)
lblDeclinePetBattle:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRWConfig.PetBattle = text
end)

if IsAddOnLoaded("DuelResponse_Blacklist") == true then

-- Whisper Blacklisted Players Checkbox

local chkWhisperBL = CreateFrame("CheckButton", nil, drwoptions, "OptionsBaseCheckButtonTemplate")
chkWhisperBL:SetPoint("TOPLEFT", lblDeclinePetBattleText, "BOTTOMLEFT", 0, -8)

	if DRWConfig.WhisperBlacklist == "ON" then
		chkWhisperBL:SetChecked(true)
	elseif DRWConfig.WhisperBlacklist == "OFF" then
		chkWhisperBL:SetChecked(false)
	end

chkWhisperBL:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRWConfig.WhisperBlacklist = 'OFF'
	elseif tick == true then
		DRWConfig.WhisperBlacklist = 'ON'
	end
end)

local chkWhisperBLText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
chkWhisperBLText:SetPoint("LEFT", chkWhisperBL, "RIGHT", 0, 1)
chkWhisperBLText:SetText(L["Send a whisper to blacklisted players"])

-- Blacklisted Player Whisper Editbox

local lblBLPlayerMsgText = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
lblBLPlayerMsgText:SetPoint("TOPLEFT", chkWhisperBL, "BOTTOMLEFT", 0, -8)
lblBLPlayerMsgText:SetText(L["Blacklisted Player:"])

local lblBLPlayerMsg = CreateFrame("EditBox", nil, drwoptions, "InputBoxTemplate")
lblBLPlayerMsg:SetPoint("LEFT", lblBLPlayerMsgText, "RIGHT", 16, 0)
lblBLPlayerMsg:SetAutoFocus(false)
lblBLPlayerMsg:SetWidth(350)
lblBLPlayerMsg:SetHeight(16)
lblBLPlayerMsg:SetMaxLetters(255)
lblBLPlayerMsg:Show()

local text = DRWConfig.BLWhisperMsg
		lblBLPlayerMsg:SetText(text)

lblBLPlayerMsg:SetScript("OnLeave", GameTooltip_Hide)
lblBLPlayerMsg:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRWConfig.BLWhisperMsg = text
end)
end

-- Save on close

local lblSaveOnClose = drwoptions:CreateFontString(nil, nil, "GameFontHighlight")
lblSaveOnClose:SetPoint("TOPLEFT", drwoptions, "BOTTOMLEFT", 8, 24)
lblSaveOnClose:SetText(L["Settings will be applied once this window is closed."])
end

elseif msg == L["reset"] or msg == "reset" then

StaticPopup_Show("RESET_DRWVARIABLES")

end

end